/**
  *  \file client/wcost.h
  *
  *  (c) 2001-2006 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WCOST_H
#define PCC_V2_CLIENT_WCOST_H

#include "ui/ui.h"
#include "game/struct.h"
#include "game/cargo.h"

class GCargoCostTransaction;

class WItemCostDisplay : public UIWidget {
 public:
    struct ItemCost {
        int32 t, d, m, mc, sup;

        ItemCost();
        ItemCost(const TCost&);
        ItemCost& operator+=(const ItemCost& rhs);
        ItemCost& operator*=(int n);
    };
 private:
    GCargoCostTransaction&  action;
    ItemCost                cost;
    int                     have_tech, need_tech;
    bool                    include_item_in_cost;
 public:
    WItemCostDisplay(GCargoCostTransaction& action, bool include_item_in_cost);
    ~WItemCostDisplay();

    void getLayoutInfo(LayoutInfo& li);
    bool handleEvent(const UIEvent& e, bool second_pass);
    void draw(GfxCanvas& can, UpdateInfo& ui);

    void setCost(const ItemCost&);
    void setTech(int have, int need);
};

#endif
