/**
  *  \file int/vars.cc
  *
  *  (c) 2001-2006 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "int/vars.h"

IntVariableNames IntVariableNames::global_names;
IntVariableValues IntVariableValues::global_values;

/**************************** IntVariableNames ***************************/

IntVariableNames::IntVariableNames()
{ }

IntVariableNames::~IntVariableNames()
{ }

IntVariableNames::index_t
IntVariableNames::lookup(string_t name)
{
    for (std::vector<string_t>::size_type i = 0; i < names.size(); ++i)
        if (name == names[i])
            return i;
    return -1;
}

IntVariableNames::index_t
IntVariableNames::add(string_t name)
{
    names.push_back(name);
    return names.size() - 1;
}

/*************************** IntVariableValues ***************************/

IntVariableValues::IntVariableValues()
{ }

IntVariableValues::~IntVariableValues()
{ }

IntObject
IntVariableValues::read(index_t index)
{
    if (index >= values.size())
        return IntObject();
    else
        return values[index];
}

void
IntVariableValues::store(index_t index, IntObject value)
{
    if (index >= values.size()) {
        if (value.isEmpty())
            return;
        if (index > values.size())
            values.insert(values.end(), index - values.size(), IntObject());
        values.push_back(value);
    } else {
        values[index] = value;
    }
}
